#!/bin/env perl

use strict;
use File::Basename qw(dirname);
use Sys::Hostname;
use feature qw(say);

use DE_EPAGES::Core::API::File qw ( CopyDirectory RunOnGlob );
use DE_EPAGES::Core::API::Script qw( RunScript );
use DE_EPAGES::Core::API::SystemCommand qw (SystemCommand);

sub Main {
    local $| = 1;

    chdir dirname $0;

    my $BackupDir = '../Backup-'. hostname();
    return unless -d '../FileChanges';
    chdir '../FileChanges';

    return if not -d 'srv/epages/eproot' and $^O eq 'MSWin32';

    RunOnGlob( 'srv/epages/eproot/Cartridges/DE_EPAGES', '*/Data/WebRoot', sub {
        say qq(CopyDirectory($_, $ENV{EPAGES_WEBROOT}, $BackupDir));
        CopyDirectory($_, $ENV{EPAGES_WEBROOT}, $BackupDir, { by => 'perl' });
               }
        );

    if ($^O eq 'MSWin32') {
        say qq(CopyDirectory('srv/epages/eproot', $ENV{EPAGES}, $BackupDir));
        CopyDirectory('srv/epages/eproot', $ENV{EPAGES}, $BackupDir, { by => 'perl' });
        return;
    }

    say qq(CopyDirectory('.', '/', $BackupDir));
    CopyDirectory('.', '/', $BackupDir, { by => 'perl' });
    SystemCommand( '/etc/init.d/epages6 perm admin', { Print => 1 });
}

RunScript(
    'Sub' => \&Main
);
